// ddxutils.h

#include <windows.h>
#include <stdio.h>
#include <ddraw.h>

#define DDXRGB888(r, g, b)  ((DWORD)(((DWORD)(BYTE)(r)) << 16) | (((WORD)(g) << 8) | (BYTE)(b)))
#define DDXRGB555(r, g, b)  ((WORD)(((BYTE)(r) >> 3) << 10) | (((BYTE)(g) >> 3) << 5) | ((BYTE)(b) >> 3))
#define DDXRGB565(r, g, b)  ((WORD)(((BYTE)(r) >> 3) << 11) | (((BYTE)(g) >> 2) << 5) | ((BYTE)(b) >> 3))

#define DDERR_PALNOBMP 2
#define DDERR_LOADNOBMP 3

int DDXCreateSurfaceFromBitmap(LPDIRECTDRAW7 lpDD, char * fName, LPDIRECTDRAWSURFACE7 * lplpSurface);
int DDXColorMatch(LPDIRECTDRAWSURFACE7 lpDDS, COLORREF colrgb);
int DDXSetColorKey(LPDIRECTDRAWSURFACE7 lpDDS, COLORREF colrgb);
int DDXCopyBitmapToSurface(LPDIRECTDRAWSURFACE7 lpDDS, HBITMAP hbm, int x, int y, int dx, int dy);
int DDXLoadBmpToSurface(LPDIRECTDRAWSURFACE7 lpDDS, char * fName);
DWORD DDXLoadBmpPalette(LPDIRECTDRAW7 lpDD, DWORD flags, char * filename, LPDIRECTDRAWPALETTE * lplpPalette);
char * DDXErrorString(DWORD code);
int DDXFade(LPDIRECTDRAWPALETTE lpDDPal, COLORREF colour, int tickcount, int sizepal);
